package com.casic.dcms.view.upload;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.media.MediaMetadataRetriever;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.core.content.ContextCompat;
import androidx.core.content.res.ResourcesCompat;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.bumptech.glide.Glide;
import com.bumptech.glide.request.RequestOptions;
import com.casic.dcms.R;
import com.casic.dcms.databinding.ActivityCommonCaseBinding;
import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.model.CaseLargeTypeBean;
import com.casic.dcms.model.CaseSmallTypeBean;
import com.casic.dcms.utils.DialogHelper;
import com.casic.dcms.utils.FileUtils;
import com.casic.dcms.utils.LocaleConstant;
import com.casic.dcms.utils.PictureSelectorHelper;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.callback.ISelectorListener;
import com.casic.dcms.view.BigImageActivity;
import com.casic.dcms.view.map.ArcGISMapActivity;
import com.casic.dcms.vm.CaseViewModel;
import com.casic.dcms.vm.CommonDataViewModel;
import com.casic.dcms.vm.UploadViewModel;
import com.gyf.immersionbar.ImmersionBar;
import com.luck.picture.lib.entity.LocalMedia;
import com.pengxh.androidx.lite.adapter.EditableImageAdapter;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.hub.ContextHub;
import com.pengxh.androidx.lite.hub.FloatHub;
import com.pengxh.androidx.lite.hub.IntHub;
import com.pengxh.androidx.lite.hub.LongHub;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.utils.ImmerseStatusBarManager;
import com.pengxh.androidx.lite.vm.LoadState;
import com.pengxh.androidx.lite.widget.audio.AudioPopupWindow;
import com.pengxh.androidx.lite.widget.audio.AudioRecodeHelper;
import com.pengxh.androidx.lite.widget.dialog.AlertControlDialog;
import com.qmuiteam.qmui.util.QMUIDisplayHelper;
import com.qmuiteam.qmui.widget.dialog.QMUIBottomSheet;
import com.qmuiteam.qmui.widget.popup.QMUIPopup;
import com.qmuiteam.qmui.widget.popup.QMUIPopups;
import com.zolad.videoslimmer.VideoSlimmer;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import cn.jzvd.Jzvd;

public class CommonCaseActivity extends AndroidxBaseActivity<ActivityCommonCaseBinding> {

    private static final String TAG = "CommonCaseActivity";
    private final Context context = CommonCaseActivity.this;
    private final List<String> imageList = new ArrayList<>();//服务器返回的拍照数据集
    private final ArrayList<String> realPaths = new ArrayList<>();//真实图片路径
    private CaseViewModel caseViewModel;
    private CommonDataViewModel commonDataViewModel;
    private UploadViewModel uploadViewModel;
    private List<CaseLargeTypeBean.DataBean> largeTypeBeans;
    private List<CaseSmallTypeBean.DataBean> smallTypeBeans;
    private ProgressDialog progressDialog;
    private EditableImageAdapter imageAdapter;
    private AudioRecodeHelper audioRecodeHelper;
    private String eorc = "";
    private String typeCode = "";
    private String typeDetailCode = "";//默认值，防止用户不选择直接跳过
    private String gridId;
    private String audioUrl, videoUrl;
    private boolean isFirstEnter = true;

    private final ActivityResultLauncher<Intent> uploadCaseLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), new ActivityResultCallback<ActivityResult>() {
        @Override
        public void onActivityResult(ActivityResult result) {
            if (result.getResultCode() == Activity.RESULT_OK) {
                Intent data = result.getData();
                if (data == null) {
                    return;
                }
                double longitude = data.getDoubleExtra("longitude", 0);
                double latitude = data.getDoubleExtra("latitude", 0);
                gridId = data.getStringExtra("gridId");
                String community = data.getStringExtra("community");

                viewBinding.longitudeView.setText(String.valueOf(longitude));
                viewBinding.latitudeView.setText(String.valueOf(latitude));
                viewBinding.communityNameView.setText(community);
            }
        }
    });

    @Override
    protected void setupTopBarLayout() {
        ImmerseStatusBarManager.setColor(this, IntHub.convertColor(this, R.color.white));
        ImmersionBar.with(this).statusBarDarkFont(true).init();

        viewBinding.titleBarLayout.titleView.setText("案卷上报");
        viewBinding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        caseViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    DialogHelper.showLoadingDialog(context, "案卷提交中，请稍后...");
                } else if (loadState == LoadState.Success) {
                    DialogHelper.dismissLoadingDialog();
                    finish();
                } else {
                    StringHub.show(context, "提交失败，请重试");
                    DialogHelper.dismissLoadingDialog();
                }
            }
        });

        uploadViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    DialogHelper.showLoadingDialog(context, "上传中，请稍后...");
                } else {
                    DialogHelper.dismissLoadingDialog();
                }
            }
        });
    }

    @Override
    public void initData() {
        largeTypeBeans = new ArrayList<>();
        smallTypeBeans = new ArrayList<>();

        caseViewModel = new ViewModelProvider(this).get(CaseViewModel.class);

        commonDataViewModel = new ViewModelProvider(this).get(CommonDataViewModel.class);
        commonDataViewModel.largeTypeModel.observe(this, new Observer<CaseLargeTypeBean>() {
            @Override
            public void onChanged(CaseLargeTypeBean typeBean) {
                if (typeBean.getCode() == 200) {
                    largeTypeBeans = typeBean.getData();
                }
            }
        });
        commonDataViewModel.smallTypeModel.observe(this, new Observer<CaseSmallTypeBean>() {
            @Override
            public void onChanged(CaseSmallTypeBean typeBean) {
                if (typeBean.getCode() == 200) {
                    //设置小类数据
                    smallTypeBeans = typeBean.getData();
                }
            }
        });

        uploadViewModel = new ViewModelProvider(this).get(UploadViewModel.class);
        uploadViewModel.imageModel.observe(this, new Observer<ActionResultBean>() {
            @Override
            public void onChanged(ActionResultBean resultBean) {
                if (resultBean.getCode() == 200) {
                    if (imageAdapter.getItemCount() <= 4) {
                        String url = resultBean.getData();
                        imageList.add(url);
                        realPaths.add(StringHelper.appendCompleteURL(url));
                        imageAdapter.setupImage(realPaths);
                    } else {
                        StringHub.show(context, "最多只能上传3张图片");
                    }
                }
            }
        });
        uploadViewModel.audioModel.observe(this, new Observer<ActionResultBean>() {
            @Override
            public void onChanged(ActionResultBean resultBean) {
                if (resultBean.getCode() == 200) {
                    audioUrl = resultBean.getData();
                    /**
                     * http://111.198.10.15:11409/static/2021-04/8fb86dae39ad4f949e934e25465d7382.m4a
                     * */
                    if (!TextUtils.isEmpty(audioUrl)) {
                        viewBinding.audioPlayerView.setVisibility(View.VISIBLE);
                        viewBinding.audioPlayerView.setAudioUrl(StringHelper.appendCompleteURL(audioUrl));
                    }
                }
            }
        });
        uploadViewModel.videoModel.observe(this, new Observer<ActionResultBean>() {
            @Override
            public void onChanged(ActionResultBean resultBean) {
                if (resultBean.getCode() == 200) {
                    //2021-04\\9d89df21173043cfb4188e68613e3e0e.mp4
                    viewBinding.addVideoView.setVisibility(View.GONE);
                    viewBinding.videoPlayerView.setVisibility(View.VISIBLE);
                    videoUrl = resultBean.getData();
                    String completeURL = StringHelper.appendCompleteURL(videoUrl);
                    viewBinding.videoPlayerView.setUp(completeURL, "", Jzvd.SCREEN_NORMAL);
                    //设置第一帧为封面
                    Glide.with(context)
                            .setDefaultRequestOptions(new RequestOptions().frame(4000000))
                            .load(completeURL)
                            .into(viewBinding.videoPlayerView.posterImageView);
                }
            }
        });

        progressDialog = new ProgressDialog(this);
        progressDialog.setMessage("视频压缩中...");
        progressDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
        progressDialog.setProgressDrawable(ResourcesCompat.getDrawable(getResources(), R.drawable.bg_progress, null));
        progressDialog.setCancelable(false);
        progressDialog.setCanceledOnTouchOutside(false);

        /**
         * 计算 +图标 大小
         *
         * CarrView水平外边距5dp
         * RelativeLayout水平内边距10dp
         * RecyclerView左边距100dp
         * */
        int realWidth = ContextHub.getScreenWidth(this) - FloatHub.dp2px(this, 40);
        int margins = FloatHub.dp2px(this, 3);
        int itemSize = (realWidth - 4 * margins) / 3;
        LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(itemSize, itemSize);
        params.setMargins(margins, margins, margins, margins);
        params.gravity = Gravity.START;
        viewBinding.addVideoView.setScaleType(ImageView.ScaleType.CENTER_CROP);
        viewBinding.addVideoView.setLayoutParams(params);

        //图片九宫格
        imageAdapter = new EditableImageAdapter(this, 3, 13);
        viewBinding.addImageRecyclerView.setAdapter(imageAdapter);
    }

    @SuppressLint("ClickableViewAccessibility")
    @Override
    public void initEvent() {
        /**
         * 选择案卷类型
         * */
        viewBinding.caseClassLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new QMUIBottomSheet.BottomListSheetBuilder(context)
                        .setTitle("案卷类型")
                        .addItem("事件")
                        .addItem("部件")
                        .setGravityCenter(true)
                        .setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                            @Override
                            public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                                dialog.dismiss();
                                viewBinding.caseClassView.setText(tag);
                                viewBinding.caseClassView.setTextColor(ContextCompat.getColor(context, R.color.mainTextColor));

                                //获取案卷大类
                                commonDataViewModel.obtainLargeType(String.valueOf(position + 1));
                            }
                        }).build().show();
            }
        });

        /**
         * 选择案卷大类
         * */
        viewBinding.caseLargeClassLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (largeTypeBeans.size() > 1) {
                    QMUIBottomSheet.BottomListSheetBuilder sheetBuilder = new QMUIBottomSheet.BottomListSheetBuilder(context);
                    sheetBuilder.setTitle("案卷大类");
                    for (CaseLargeTypeBean.DataBean dataBean : largeTypeBeans) {
                        sheetBuilder.addItem(dataBean.getTypeName());
                    }
                    sheetBuilder.setGravityCenter(true).setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                        @Override
                        public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                            dialog.dismiss();
                            viewBinding.caseLargeClassView.setText(tag);
                            viewBinding.caseLargeClassView.setTextColor(ContextCompat.getColor(context, R.color.mainTextColor));

                            //获取案卷小类
                            CaseLargeTypeBean.DataBean dataBean = largeTypeBeans.get(position);
                            eorc = dataBean.getEorc();
                            typeCode = dataBean.getTypeCode();
                            String typeId = dataBean.getId();

                            commonDataViewModel.obtainSmallType(eorc, typeId);
                        }
                    }).build().show();
                }
            }
        });

        /**
         * 选择案卷小类
         * */
        viewBinding.caseSmallClassLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (smallTypeBeans.size() > 1) {
                    QMUIBottomSheet.BottomListSheetBuilder sheetBuilder = new QMUIBottomSheet.BottomListSheetBuilder(context);
                    sheetBuilder.setTitle("案卷小类");
                    for (CaseSmallTypeBean.DataBean dataBean : smallTypeBeans) {
                        sheetBuilder.addItem(dataBean.getTypeDetailName());
                    }
                    sheetBuilder.setGravityCenter(true).setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                        @Override
                        public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                            dialog.dismiss();
                            viewBinding.caseSmallClassView.setText(tag);
                            viewBinding.caseSmallClassView.setTextColor(ContextCompat.getColor(context, R.color.mainTextColor));

                            typeDetailCode = smallTypeBeans.get(position).getTypeDetailCode();
                        }
                    }).build().show();
                }
            }
        });

        /**
         * 选择经纬度
         * */
        viewBinding.locationMapView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String type = viewBinding.caseClassView.getText().toString();
                if (type.equals("")) {
                    StringHub.show(context, "请先选择案卷类型");
                    return;
                }
                Intent intent = new Intent(context, ArcGISMapActivity.class);
                intent.putExtra("type", type);
                uploadCaseLauncher.launch(intent);
            }
        });

        /**
         * 案卷录音
         * */
        AudioPopupWindow.create(this, new AudioPopupWindow.IWindowListener() {
            @Override
            public void onViewCreated(PopupWindow window, ImageView imageView, TextView textView) {
                viewBinding.recodeAudioButton.setOnTouchListener(new View.OnTouchListener() {
                    @Override
                    public boolean onTouch(View v, MotionEvent event) {
                        switch (event.getAction()) {
                            case MotionEvent.ACTION_DOWN:
                                viewBinding.recodeAudioButton.animate().scaleX(0.75f).scaleY(0.75f).setDuration(100).start();
                                window.showAtLocation(viewBinding.caseLayout, Gravity.CENTER, 0, 0);
                                audioRecodeHelper.startRecordAudio(ContextHub.createAudioFile(CommonCaseActivity.this).toString());
                                break;
                            case MotionEvent.ACTION_UP:
                                audioRecodeHelper.stopRecordAudio();//结束录音（保存录音文件）
                                window.dismiss();
                                viewBinding.recodeAudioButton.animate().scaleX(1.0f).scaleY(1.0f).setDuration(100).start();
                                break;
                        }
                        return true;
                    }
                });

                audioRecodeHelper = new AudioRecodeHelper();
                audioRecodeHelper.setOnAudioStatusUpdateListener(new AudioRecodeHelper.OnAudioStatusUpdateListener() {
                    @Override
                    public void onUpdate(double db, long time) {
                        imageView.getDrawable().setLevel((int) (3000 + 6000 * db / 100));
                        textView.setText(LongHub.millsToTime(time));
                    }

                    @Override
                    public void onStop(String filePath) {
                        uploadViewModel.uploadAudio(new File(filePath));
                    }
                });
            }
        });

        /**
         * 案卷视频
         * */
        viewBinding.addVideoView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PictureSelectorHelper.takeVideo(context, new ISelectorListener() {
                    @Override
                    public void onSuccess(ArrayList<LocalMedia> result) {
                        LocalMedia media = result.get(0);
                        //"realPath":"/storage/emulated/0/Movies/VID_20210426_17552226.mp4"
                        //需要手动压缩视频
                        String mediaRealPath = media.getRealPath();
                        if (TextUtils.isEmpty(mediaRealPath)) {
                            //部分手机getRealPath可能为空，需要备用路径
                            mediaRealPath = media.getPath();
                        }
                        if (TextUtils.isEmpty(mediaRealPath) || mediaRealPath.equals("")) {
                            //如果默认和备用路径还是为空，则不压缩上传
                            StringHub.show(context, "请先选择案卷类型");
                            return;
                        }
                        MediaMetadataRetriever retriever = new MediaMetadataRetriever();
                        retriever.setDataSource(mediaRealPath);
                        String defaultRotation = retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_VIDEO_ROTATION);
                        String defaultBitrate = retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_BITRATE);

                        assert defaultRotation != null;
                        compressVideo(mediaRealPath, defaultRotation, defaultBitrate);
                    }
                });
            }
        });

        /**
         * 重拍视频
         * */
        viewBinding.deleteView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (viewBinding.videoPlayerView.isShown()) {
                    new AlertControlDialog.Builder()
                            .setContext(context)
                            .setTitle("提示")
                            .setMessage("确定重新拍摄视频材料？")
                            .setNegativeButton("取消")
                            .setPositiveButton("确定")
                            .setOnDialogButtonClickListener(new AlertControlDialog.OnDialogButtonClickListener() {
                                @Override
                                public void onConfirmClick() {
                                    viewBinding.videoPlayerView.setVisibility(View.GONE);
                                    viewBinding.addVideoView.setVisibility(View.VISIBLE);
                                }

                                @Override
                                public void onCancelClick() {

                                }
                            }).build().show();
                }
            }
        });

        /**
         * 图片九宫格事件处理
         * */
        imageAdapter.setOnItemClickListener(new EditableImageAdapter.OnItemClickListener() {
            @Override
            public void onAddImageClick() {
                PictureSelectorHelper.selectPicture(context, new ISelectorListener() {
                    @Override
                    public void onSuccess(ArrayList<LocalMedia> result) {
                        if (result.size() == 1) {
                            uploadViewModel.uploadImage(new File(result.get(0).getRealPath()));
                        } else {
                            for (LocalMedia localMedia : result) {
                                uploadViewModel.uploadImage(new File(localMedia.getRealPath()));
                            }
                        }
                    }
                });
            }

            @Override
            public void onItemClick(int position) {
                if (realPaths.get(position).isEmpty()) {
                    StringHub.show(context, "图片加载失败，无法查看大图");
                } else {
                    ContextHub.navigatePageTo(context, BigImageActivity.class, position, realPaths);
                }
            }

            @Override
            public void onItemLongClick(View view, int position) {
                imageList.remove(position);
                imageAdapter.deleteImage(position);
            }
        });

        viewBinding.submitButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                submitCase();
            }
        });
    }

    /**
     * 6.0以上视频压缩
     */
    private void compressVideo(String mediaRealPath, String defaultRotation, String defaultBitrate) {
        Log.d(TAG, "defaultRotation: " + defaultRotation + ", defaultBitrate: " + defaultBitrate);
        String outputVideoFile = FileUtils.getOutputVideoFile();
        int width, height, bitrate;
        if (defaultRotation.equals("90")) {//视频为竖屏，0为横屏
            width = LocaleConstant.DEFAULT_WIDTH / 2;
            height = LocaleConstant.DEFAULT_HEIGHT / 2;
        } else {
            width = LocaleConstant.DEFAULT_HEIGHT / 2;
            height = LocaleConstant.DEFAULT_WIDTH / 2;
        }
        if (TextUtils.isEmpty(defaultBitrate) || defaultBitrate.equals("")) {
            bitrate = LocaleConstant.BITRATE;
        } else {
            bitrate = Integer.parseInt(defaultBitrate) / 2;
        }
        VideoSlimmer.convertVideo(mediaRealPath, outputVideoFile, width, height, LocaleConstant.BITRATE, new VideoSlimmer.ProgressListener() {
            @Override
            public void onStart() {
                progressDialog.show();
            }

            @Override
            public void onProgress(float percent) {
                progressDialog.setProgress((int) percent);
            }

            @Override
            public void onFinish(boolean result) {
                if (result) {
                    uploadViewModel.uploadVideo(new File(outputVideoFile));
                } else {
                    StringHub.show(CommonCaseActivity.this, "请先选择案卷类型");
                }
                progressDialog.dismiss();
            }
        });
    }

    /**
     * 首次进入页面显示引导Popup
     */
    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        if (isFirstEnter) {
            TextView textView = new TextView(this);
            int padding = QMUIDisplayHelper.dp2px(this, 10);
            textView.setPadding(padding, padding, padding, padding);
            textView.setGravity(Gravity.CENTER);
            textView.setText("按住即可开始录音");
            QMUIPopups.popup(this, QMUIDisplayHelper.dp2px(this, 150))
                    .preferredDirection(QMUIPopup.DIRECTION_BOTTOM)
                    .view(textView)
                    .shadow(true)
                    .arrow(true)
                    .animStyle(QMUIPopup.ANIM_AUTO)
                    .dimAmount(0.6f)//60%透明度
                    .onDismiss(null)
                    .show(viewBinding.recodeAudioButton);
            isFirstEnter = false;
        }
    }

    /**
     * 案卷提交
     */
    private void submitCase() {
        String longitude = viewBinding.longitudeView.getText().toString();
        String latitude = viewBinding.latitudeView.getText().toString();
        if (longitude.equals("0") || latitude.equals("0") || TextUtils.isEmpty(longitude) || TextUtils.isEmpty(latitude)) {
            StringHub.show(this, "经纬度异常，请重新选择位置");
            return;
        }
        if (eorc.equals("") || typeCode.equals("")) {
            StringHub.show(this, "案卷大类还未选择");
            return;
        }
        if (typeDetailCode.equals("")) {
            StringHub.show(this, "案卷小类还未选择");
            return;
        }
        if (TextUtils.isEmpty(gridId)) {
            StringHub.show(this, "网格ID异常，请重新地图选点");
            return;
        }
        String fieldIntro = viewBinding.caseLocationView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(fieldIntro)) {
            StringHub.show(this, "案卷地点还未填写");
            return;
        }
        String description = viewBinding.caseDetailEditView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(description)) {
            StringHub.show(this, "案卷情况还未填写");
            return;
        }
        caseViewModel.submitCase("0", "0", longitude, latitude,
                "2", "1", eorc, typeCode, typeDetailCode,
                gridId.substring(0, 6),
                gridId.substring(0, 9),
                gridId.substring(0, 12),
                gridId, description, fieldIntro,
                StringHelper.reformatURL(imageList), audioUrl, videoUrl, 0, 0);
    }

    @Override
    public void onBackPressed() {
        if (Jzvd.backPress()) {
            return;
        }
        super.onBackPressed();
    }

    @Override
    protected void onPause() {
        super.onPause();
        Jzvd.releaseAllVideos();
    }
}